/*-
 ***********************************************************************
 *
 * $Id: sys-includes.h,v 1.20 2012/01/07 07:56:14 mavrik Exp $
 *
 ***********************************************************************
 *
 * Copyright 2001-2012 The WebJob Project, All Rights Reserved.
 *
 ***********************************************************************
 */
#ifndef _SYS_INCLUDES_H_INCLUDED
#define _SYS_INCLUDES_H_INCLUDED

#ifdef WEBJOB_SOLARIS
#ifndef __EXTENSIONS__
#define __EXTENSIONS__ /* This is used to get localtime_r() on Solaris. */
#endif
#endif

#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>

#ifdef UNIX
#include <ctype.h>
#include <dirent.h>
#include <fcntl.h>
#include <limits.h>
#include <math.h>
#include <netdb.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <sys/utsname.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>
#include <sys/wait.h>
#include <setjmp.h>
#ifdef WEBJOB_AIX
#include <strings.h>
#include <sys/statfs.h>
#include <sys/statvfs.h>
#include <sys/sysmacros.h>
#include <sys/vmount.h>
#endif
#ifdef WEBJOB_LINUX
#include <sys/sysmacros.h>
#include <sys/vfs.h>
#endif
#ifdef WEBJOB_SOLARIS
#include <sys/sysmacros.h>
#include <sys/statvfs.h>
#endif
#ifdef WEBJOB_BSD
#include <sys/param.h>
#include <sys/mount.h>
#endif
#endif

#ifdef WIN32
#include <windows.h>
#include <ctype.h>
#include <direct.h>
#include <fcntl.h>
#include <io.h>
#include <process.h>
#include <stdlib.h>
#include <tchar.h>
#include <time.h>
#include <winsock.h>
#endif

#endif /* !_SYS_INCLUDES_H_INCLUDED */
