/*-
 ***********************************************************************
 *
 * $Id: all-includes.h,v 1.12 2012/01/07 08:01:17 mavrik Exp $
 *
 ***********************************************************************
 *
 * Copyright 2006-2012 The WebJob Project, All Rights Reserved.
 *
 ***********************************************************************
 */
#ifndef _ALL_INCLUDES_H_INCLUDED
#define _ALL_INCLUDES_H_INCLUDED

#if defined(UNIX) || defined(MINGW32)
#include "config.h"
#endif

#include <ctype.h>
#ifdef UNIX
#include <dirent.h>
#endif
#include <errno.h>
#include <openssl/ssl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#ifdef UNIX
#include <unistd.h>
#endif
#ifdef WIN32
#include <fcntl.h>
#include <io.h>
#include <tchar.h>
#include <windows.h>
#endif

#ifdef USE_AP_SNPRINTF
#include <limits.h>
#include <math.h>
#include <netdb.h>
#include "ap_snprintf.h"
#define snprintf ap_snprintf
#endif

#include "dsv.h"
#include "dsv-pool.h"
#include "options.h"
#include "ssl.h"
#include "ssl-pool.h"
#include "webjob-dsvtool.h"

#ifdef WIN32
#ifndef WEBJOB_MINGW32
#define fileno _fileno
#endif
#define fstat _fstat
#define snprintf _snprintf
#define strcasecmp _stricmp
#define stat _stat
#endif

#ifndef MESSAGE_SIZE
#define MESSAGE_SIZE 1024
#endif

#endif /* !_ALL_INCLUDES_H_INCLUDED */
